#!/usr/bin/python

import sys

ff=open(sys.argv[1], "r")

stack = []

def disp_stack():
    global stack
    cnt=0

    for k in stack:
        print "\t%04x: "%cnt,k
        cnt += 1

for ll in ff:
    rll = ll.split(": ")[1][:-1]
    #print ">>>>>>>>>>",rll
    if rll.startswith("PUSH"):
        num = int(rll.split("[")[1].split("]")[0])
        args = rll.split("]")[1].lstrip(" ")
        args = args.split(" ")
        for k in args:
            if k != '':
                stack.append(k)
    
    elif rll.startswith("RS"):
        ind = stack.pop()
        stack.append("RS["+ind+"]")
    elif rll.startswith("ROLL"):
        a=stack.pop()
        b=stack.pop()
        c=stack.pop()
        stack.append(b)
        stack.append(a)
        stack.append(c)
    elif rll.startswith("MUL"):
        a=stack.pop()
        b=stack.pop()
        stack.append("("+a+"/64 * "+b+")")
    elif rll.startswith("ADD"):
        a=stack.pop()
        b=stack.pop()
        stack.append("("+a+" + "+b+")")
    elif rll.startswith("SUB"):
        a=stack.pop()
        b=stack.pop()
        stack.append("("+b+" - "+a+")")
    elif rll.startswith("MINDEX"):
        k=stack.pop()
        ind = len(stack)-int(k)
        u=stack[ind]
        stack = stack[:ind] + stack[ind+1:]
        stack.append(u)
    elif rll.startswith("EQ"):
        a=stack.pop()
        b=stack.pop()
        stack.append("("+a+" == "+b+")")
    elif rll.startswith("AND"):
        a=stack.pop()
        b=stack.pop()
        stack.append("("+a+" AND "+b+")")
    elif rll.startswith("SWAP"):
        a=stack.pop()
        b=stack.pop()
        stack.append(a)
        stack.append(b)
    elif rll.startswith("WS"):
        a=stack.pop()
        b=stack.pop()
        print a
    elif rll.startswith("IF"):
        a = stack.pop()
    elif rll.startswith("ELSE") or rll.startswith("EIF") or rll.startswith("SVTCA"):
        a = 1
    else:
        #print "Error",rll
        sys.exit(1)

    #disp_stack()
